// -*- c++ -*-
// Generated by gmmproc 2.44.0 -- DO NOT MODIFY!
#ifndef _WNCKMM_APPLICATION_H
#define _WNCKMM_APPLICATION_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/** This file is part of wnckmm

    Copyright (c) 2013 Povilas Kanapickas  <povilas@radix.lt>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <gdkmm/pixbuf.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _WnckApplication WnckApplication;
typedef struct _WnckApplicationClass WnckApplicationClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Wnck
{ class Application_Class; } // namespace Wnck
namespace Wnck {

class Window;

/** This represents an application.
 */

class Application : public Glib::Object
{
    
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Application CppObjectType;
  typedef Application_Class CppClassType;
  typedef WnckApplication BaseObjectType;
  typedef WnckApplicationClass BaseClassType;

private:
  friend class Application_Class;
  static CppClassType application_class_;

private:
  // noncopyable
  Application(const Application&);
  Application& operator=(const Application&);

protected:
  explicit Application(const Glib::ConstructParams& construct_params);
  explicit Application(WnckApplication* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Application();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  WnckApplication*       gobj()       { return reinterpret_cast<WnckApplication*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const WnckApplication* gobj() const { return reinterpret_cast<WnckApplication*>(gobject_); }

private:


protected:
    Application();

public:
    
  static Window* get_for_xid(gulong xid);
    
  gulong get_xid() const;
    
  std::string get_name() const;
    
  int get_pid() const;
    
  int is_icon_fallback() const;

    // TODO: is pixbuf const?;
    
  Glib::RefPtr<Gdk::Pixbuf> get_icon() const;
    // TODO: is pixbuf const?;
    
  Glib::RefPtr<Gdk::Pixbuf> get_mini_icon() const;

    
  std::string get_startup_id() const;

  
  Glib::ListHandle<Window*> get_windows() const;
    
    
  int get_window_count() const;

    
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%name_changed()</tt>
   *
   */

  Glib::SignalProxy0< void > signal_name_changed();

    
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%icon_changed()</tt>
   *
   */

  Glib::SignalProxy0< void > signal_icon_changed();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  /// This is a default handler for the signal signal_name_changed().
  virtual void on_name_changed();
  /// This is a default handler for the signal signal_icon_changed().
  virtual void on_icon_changed();


};

} //namespace Wnck


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Wnck::Application
   */
  Wnck::Application* wrap(WnckApplication* object, bool take_copy = false);
}


#endif /* _WNCKMM_APPLICATION_H */

