// -*- c++ -*-
// Generated by gmmproc 2.44.0 -- DO NOT MODIFY!
#ifndef _WNCKMM_WORKSPACE_H
#define _WNCKMM_WORKSPACE_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/** This file is part of wnckmm

    Copyright (c) 2013 Povilas Kanapickas  <povilas@radix.lt>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _WnckWorkspace WnckWorkspace;
typedef struct _WnckWorkspaceClass WnckWorkspaceClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Wnck
{ class Workspace_Class; } // namespace Wnck
namespace Wnck {

class Screen;

/** @addtogroup wnckmmEnums wnckmm Enums and Flags */

/** 
 *
 * @ingroup wnckmmEnums
 */
enum MotionDirection
{
  MOTION_UP = -1,
  MOTION_DOWN = -2,
  MOTION_LEFT = -3,
  MOTION_RIGHT = -4
};

} // namespace Wnck


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Wnck::MotionDirection> : public Glib::Value_Enum<Wnck::MotionDirection>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Wnck
{


/** This represents a workspace.
 */

class Workspace : public Glib::Object
{
    
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Workspace CppObjectType;
  typedef Workspace_Class CppClassType;
  typedef WnckWorkspace BaseObjectType;
  typedef WnckWorkspaceClass BaseClassType;

private:
  friend class Workspace_Class;
  static CppClassType workspace_class_;

private:
  // noncopyable
  Workspace(const Workspace&);
  Workspace& operator=(const Workspace&);

protected:
  explicit Workspace(const Glib::ConstructParams& construct_params);
  explicit Workspace(WnckWorkspace* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Workspace();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  WnckWorkspace*       gobj()       { return reinterpret_cast<WnckWorkspace*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const WnckWorkspace* gobj() const { return reinterpret_cast<WnckWorkspace*>(gobject_); }

private:


protected:
    Workspace();

public:
    
  Screen* get_screen() const;
    
  int get_number() const;
    
  std::string get_name() const;
    
  void set_name(const std::string& name) const;

    
  int get_width() const;
    
  int get_height() const;
    
  int get_viewport_x() const;
    
  int get_viewport_y() const;
    
  bool is_virtual() const;
    
  int get_layout_row() const;
    
  int get_layout_column() const;
    
  Workspace* get_neighbor(MotionDirection direction) const;
    
  void activate(guint32 timestamp);

    
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%name_changed()</tt>
   *
   */

  Glib::SignalProxy0< void > signal_name_changed();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  /// This is a default handler for the signal signal_name_changed().
  virtual void on_name_changed();


};

} //namespace Wnck


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Wnck::Workspace
   */
  Wnck::Workspace* wrap(WnckWorkspace* object, bool take_copy = false);
}


#endif /* _WNCKMM_WORKSPACE_H */

